// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/ActionId.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACTION_ID__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACTION_ID__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'originating_station_id'
#include "etsi_its_cam_ts_msgs/msg/detail/station_id__struct.hpp"
// Member 'sequence_number'
#include "etsi_its_cam_ts_msgs/msg/detail/sequence_number__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__ActionId __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__ActionId __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ActionId_
{
  using Type = ActionId_<ContainerAllocator>;

  explicit ActionId_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : originating_station_id(_init),
    sequence_number(_init)
  {
    (void)_init;
  }

  explicit ActionId_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : originating_station_id(_alloc, _init),
    sequence_number(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _originating_station_id_type =
    etsi_its_cam_ts_msgs::msg::StationId_<ContainerAllocator>;
  _originating_station_id_type originating_station_id;
  using _sequence_number_type =
    etsi_its_cam_ts_msgs::msg::SequenceNumber_<ContainerAllocator>;
  _sequence_number_type sequence_number;

  // setters for named parameter idiom
  Type & set__originating_station_id(
    const etsi_its_cam_ts_msgs::msg::StationId_<ContainerAllocator> & _arg)
  {
    this->originating_station_id = _arg;
    return *this;
  }
  Type & set__sequence_number(
    const etsi_its_cam_ts_msgs::msg::SequenceNumber_<ContainerAllocator> & _arg)
  {
    this->sequence_number = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__ActionId
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__ActionId
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::ActionId_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ActionId_ & other) const
  {
    if (this->originating_station_id != other.originating_station_id) {
      return false;
    }
    if (this->sequence_number != other.sequence_number) {
      return false;
    }
    return true;
  }
  bool operator!=(const ActionId_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ActionId_

// alias to use template instance with default allocator
using ActionId =
  etsi_its_cam_ts_msgs::msg::ActionId_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ACTION_ID__STRUCT_HPP_
