// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/InterferenceManagementZone.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/interference_management_zone__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `zone_definition`
#include "etsi_its_cam_ts_msgs/msg/detail/interference_management_zone_definition__functions.h"
// Member `management_info`
#include "etsi_its_cam_ts_msgs/msg/detail/interference_management_info__functions.h"

bool
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__init(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone * msg)
{
  if (!msg) {
    return false;
  }
  // zone_definition
  if (!etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneDefinition__init(&msg->zone_definition)) {
    etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__fini(msg);
    return false;
  }
  // management_info
  if (!etsi_its_cam_ts_msgs__msg__InterferenceManagementInfo__init(&msg->management_info)) {
    etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__fini(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone * msg)
{
  if (!msg) {
    return;
  }
  // zone_definition
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneDefinition__fini(&msg->zone_definition);
  // management_info
  etsi_its_cam_ts_msgs__msg__InterferenceManagementInfo__fini(&msg->management_info);
}

bool
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__are_equal(const etsi_its_cam_ts_msgs__msg__InterferenceManagementZone * lhs, const etsi_its_cam_ts_msgs__msg__InterferenceManagementZone * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // zone_definition
  if (!etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneDefinition__are_equal(
      &(lhs->zone_definition), &(rhs->zone_definition)))
  {
    return false;
  }
  // management_info
  if (!etsi_its_cam_ts_msgs__msg__InterferenceManagementInfo__are_equal(
      &(lhs->management_info), &(rhs->management_info)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__copy(
  const etsi_its_cam_ts_msgs__msg__InterferenceManagementZone * input,
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZone * output)
{
  if (!input || !output) {
    return false;
  }
  // zone_definition
  if (!etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneDefinition__copy(
      &(input->zone_definition), &(output->zone_definition)))
  {
    return false;
  }
  // management_info
  if (!etsi_its_cam_ts_msgs__msg__InterferenceManagementInfo__copy(
      &(input->management_info), &(output->management_info)))
  {
    return false;
  }
  return true;
}

etsi_its_cam_ts_msgs__msg__InterferenceManagementZone *
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZone * msg = (etsi_its_cam_ts_msgs__msg__InterferenceManagementZone *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone));
  bool success = etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__destroy(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence__init(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZone * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__InterferenceManagementZone *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence__fini(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence *
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence * array = (etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence__destroy(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence * input,
  etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__InterferenceManagementZone);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__InterferenceManagementZone * data =
      (etsi_its_cam_ts_msgs__msg__InterferenceManagementZone *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__InterferenceManagementZone__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
