// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/IvimReference.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__IVIM_REFERENCE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__IVIM_REFERENCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'service_provider_id'
#include "etsi_its_cam_ts_msgs/msg/detail/provider__struct.hpp"
// Member 'ivi_identification_number'
#include "etsi_its_cam_ts_msgs/msg/detail/ivi_identification_number__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__IvimReference __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__IvimReference __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct IvimReference_
{
  using Type = IvimReference_<ContainerAllocator>;

  explicit IvimReference_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : service_provider_id(_init),
    ivi_identification_number(_init)
  {
    (void)_init;
  }

  explicit IvimReference_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : service_provider_id(_alloc, _init),
    ivi_identification_number(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _service_provider_id_type =
    etsi_its_cam_ts_msgs::msg::Provider_<ContainerAllocator>;
  _service_provider_id_type service_provider_id;
  using _ivi_identification_number_type =
    etsi_its_cam_ts_msgs::msg::IviIdentificationNumber_<ContainerAllocator>;
  _ivi_identification_number_type ivi_identification_number;

  // setters for named parameter idiom
  Type & set__service_provider_id(
    const etsi_its_cam_ts_msgs::msg::Provider_<ContainerAllocator> & _arg)
  {
    this->service_provider_id = _arg;
    return *this;
  }
  Type & set__ivi_identification_number(
    const etsi_its_cam_ts_msgs::msg::IviIdentificationNumber_<ContainerAllocator> & _arg)
  {
    this->ivi_identification_number = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__IvimReference
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__IvimReference
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::IvimReference_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const IvimReference_ & other) const
  {
    if (this->service_provider_id != other.service_provider_id) {
      return false;
    }
    if (this->ivi_identification_number != other.ivi_identification_number) {
      return false;
    }
    return true;
  }
  bool operator!=(const IvimReference_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct IvimReference_

// alias to use template instance with default allocator
using IvimReference =
  etsi_its_cam_ts_msgs::msg::IvimReference_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__IVIM_REFERENCE__STRUCT_HPP_
