﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/LanePositionAndType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_AND_TYPE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_AND_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'LANE_TYPE_DEFAULT'.
enum
{
  etsi_its_cam_ts_msgs__msg__LanePositionAndType__LANE_TYPE_DEFAULT = 0
};

/// Constant 'DIRECTION_DEFAULT'.
enum
{
  etsi_its_cam_ts_msgs__msg__LanePositionAndType__DIRECTION_DEFAULT = 0
};

// Include directives for member types
// Member 'transversal_position'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position__struct.h"
// Member 'lane_type'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_type__struct.h"
// Member 'direction'
#include "etsi_its_cam_ts_msgs/msg/detail/direction__struct.h"

/// Struct defined in msg/LanePositionAndType in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__LanePositionAndType
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// LanePositionAndType::= SEQUENCE {
  ///     transversalPosition    LanePosition,
  ///     laneType               LaneType DEFAULT traffic,
  ///     direction              Direction DEFAULT sameDirection,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF indicates a transversal position in resolution of lanes and other associated details.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field transversalPosition: the transversal position.
  /// *
  /// * @field laneType: the type of the lane identified in the component transversalPosition. By default set to `traffic`.
  /// *
  /// * @field direction: the traffic direction for the lane position relative to a defined reference direction. By default set to `sameDirection`, i.e. following the reference direction.
  /// *
  /// * @category Road topology information
  /// * @revision: direction added in V2.2.1
  etsi_its_cam_ts_msgs__msg__LanePosition transversal_position;
  etsi_its_cam_ts_msgs__msg__LaneType lane_type;
  etsi_its_cam_ts_msgs__msg__Direction direction;
} etsi_its_cam_ts_msgs__msg__LanePositionAndType;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__LanePositionAndType.
typedef struct etsi_its_cam_ts_msgs__msg__LanePositionAndType__Sequence
{
  etsi_its_cam_ts_msgs__msg__LanePositionAndType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__LanePositionAndType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_AND_TYPE__STRUCT_H_
