// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/MitigationPerTechnologyClass.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__MITIGATION_PER_TECHNOLOGY_CLASS__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__MITIGATION_PER_TECHNOLOGY_CLASS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'access_technology_class'
#include "etsi_its_cam_ts_msgs/msg/detail/access_technology_class__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__MitigationPerTechnologyClass __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__MitigationPerTechnologyClass __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MitigationPerTechnologyClass_
{
  using Type = MitigationPerTechnologyClass_<ContainerAllocator>;

  explicit MitigationPerTechnologyClass_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : access_technology_class(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->low_duty_cycle = 0;
      this->low_duty_cycle_is_present = false;
      this->power_reduction = 0;
      this->power_reduction_is_present = false;
      this->dmc_toff_limit = 0;
      this->dmc_toff_limit_is_present = false;
      this->dmc_ton_limit = 0;
      this->dmc_ton_limit_is_present = false;
    }
  }

  explicit MitigationPerTechnologyClass_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : access_technology_class(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->low_duty_cycle = 0;
      this->low_duty_cycle_is_present = false;
      this->power_reduction = 0;
      this->power_reduction_is_present = false;
      this->dmc_toff_limit = 0;
      this->dmc_toff_limit_is_present = false;
      this->dmc_ton_limit = 0;
      this->dmc_ton_limit_is_present = false;
    }
  }

  // field types and members
  using _access_technology_class_type =
    etsi_its_cam_ts_msgs::msg::AccessTechnologyClass_<ContainerAllocator>;
  _access_technology_class_type access_technology_class;
  using _low_duty_cycle_type =
    uint16_t;
  _low_duty_cycle_type low_duty_cycle;
  using _low_duty_cycle_is_present_type =
    bool;
  _low_duty_cycle_is_present_type low_duty_cycle_is_present;
  using _power_reduction_type =
    uint8_t;
  _power_reduction_type power_reduction;
  using _power_reduction_is_present_type =
    bool;
  _power_reduction_is_present_type power_reduction_is_present;
  using _dmc_toff_limit_type =
    uint16_t;
  _dmc_toff_limit_type dmc_toff_limit;
  using _dmc_toff_limit_is_present_type =
    bool;
  _dmc_toff_limit_is_present_type dmc_toff_limit_is_present;
  using _dmc_ton_limit_type =
    uint8_t;
  _dmc_ton_limit_type dmc_ton_limit;
  using _dmc_ton_limit_is_present_type =
    bool;
  _dmc_ton_limit_is_present_type dmc_ton_limit_is_present;

  // setters for named parameter idiom
  Type & set__access_technology_class(
    const etsi_its_cam_ts_msgs::msg::AccessTechnologyClass_<ContainerAllocator> & _arg)
  {
    this->access_technology_class = _arg;
    return *this;
  }
  Type & set__low_duty_cycle(
    const uint16_t & _arg)
  {
    this->low_duty_cycle = _arg;
    return *this;
  }
  Type & set__low_duty_cycle_is_present(
    const bool & _arg)
  {
    this->low_duty_cycle_is_present = _arg;
    return *this;
  }
  Type & set__power_reduction(
    const uint8_t & _arg)
  {
    this->power_reduction = _arg;
    return *this;
  }
  Type & set__power_reduction_is_present(
    const bool & _arg)
  {
    this->power_reduction_is_present = _arg;
    return *this;
  }
  Type & set__dmc_toff_limit(
    const uint16_t & _arg)
  {
    this->dmc_toff_limit = _arg;
    return *this;
  }
  Type & set__dmc_toff_limit_is_present(
    const bool & _arg)
  {
    this->dmc_toff_limit_is_present = _arg;
    return *this;
  }
  Type & set__dmc_ton_limit(
    const uint8_t & _arg)
  {
    this->dmc_ton_limit = _arg;
    return *this;
  }
  Type & set__dmc_ton_limit_is_present(
    const bool & _arg)
  {
    this->dmc_ton_limit_is_present = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t LOW_DUTY_CYCLE_MIN =
    0u;
  static constexpr uint16_t LOW_DUTY_CYCLE_MAX =
    10000u;
  static constexpr uint8_t POWER_REDUCTION_MIN =
    0u;
  static constexpr uint8_t POWER_REDUCTION_MAX =
    30u;
  static constexpr uint16_t DMC_TOFF_LIMIT_MIN =
    0u;
  static constexpr uint16_t DMC_TOFF_LIMIT_MAX =
    1200u;
  static constexpr uint8_t DMC_TON_LIMIT_MIN =
    0u;
  static constexpr uint8_t DMC_TON_LIMIT_MAX =
    20u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__MitigationPerTechnologyClass
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__MitigationPerTechnologyClass
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MitigationPerTechnologyClass_ & other) const
  {
    if (this->access_technology_class != other.access_technology_class) {
      return false;
    }
    if (this->low_duty_cycle != other.low_duty_cycle) {
      return false;
    }
    if (this->low_duty_cycle_is_present != other.low_duty_cycle_is_present) {
      return false;
    }
    if (this->power_reduction != other.power_reduction) {
      return false;
    }
    if (this->power_reduction_is_present != other.power_reduction_is_present) {
      return false;
    }
    if (this->dmc_toff_limit != other.dmc_toff_limit) {
      return false;
    }
    if (this->dmc_toff_limit_is_present != other.dmc_toff_limit_is_present) {
      return false;
    }
    if (this->dmc_ton_limit != other.dmc_ton_limit) {
      return false;
    }
    if (this->dmc_ton_limit_is_present != other.dmc_ton_limit_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const MitigationPerTechnologyClass_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MitigationPerTechnologyClass_

// alias to use template instance with default allocator
using MitigationPerTechnologyClass =
  etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t MitigationPerTechnologyClass_<ContainerAllocator>::LOW_DUTY_CYCLE_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t MitigationPerTechnologyClass_<ContainerAllocator>::LOW_DUTY_CYCLE_MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MitigationPerTechnologyClass_<ContainerAllocator>::POWER_REDUCTION_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MitigationPerTechnologyClass_<ContainerAllocator>::POWER_REDUCTION_MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t MitigationPerTechnologyClass_<ContainerAllocator>::DMC_TOFF_LIMIT_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t MitigationPerTechnologyClass_<ContainerAllocator>::DMC_TOFF_LIMIT_MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MitigationPerTechnologyClass_<ContainerAllocator>::DMC_TON_LIMIT_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MitigationPerTechnologyClass_<ContainerAllocator>::DMC_TON_LIMIT_MAX;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__MITIGATION_PER_TECHNOLOGY_CLASS__STRUCT_HPP_
