﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/ProtectedZoneId.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_ZONE_ID__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_ZONE_ID__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__ProtectedZoneId__MIN = 0ul
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__ProtectedZoneId__MAX = 134217727ul
};

/// Struct defined in msg/ProtectedZoneId in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__ProtectedZoneId
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// ProtectedZoneId ::= INTEGER (0.. 134217727)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the indentifier of a protected communication zone.
  /// *
  /// *
  /// * @category: Infrastructure information, Communication information
  /// * @revision: Revision in V2.1.1 (changed name from ProtectedZoneID to ProtectedZoneId)
  uint32_t value;
} etsi_its_cam_ts_msgs__msg__ProtectedZoneId;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__ProtectedZoneId.
typedef struct etsi_its_cam_ts_msgs__msg__ProtectedZoneId__Sequence
{
  etsi_its_cam_ts_msgs__msg__ProtectedZoneId * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__ProtectedZoneId__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PROTECTED_ZONE_ID__STRUCT_H_
