// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/VerticalAcceleration.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/vertical_acceleration__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `vertical_acceleration_value`
#include "etsi_its_cam_ts_msgs/msg/detail/vertical_acceleration_value__functions.h"
// Member `vertical_acceleration_confidence`
#include "etsi_its_cam_ts_msgs/msg/detail/acceleration_confidence__functions.h"

bool
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__init(etsi_its_cam_ts_msgs__msg__VerticalAcceleration * msg)
{
  if (!msg) {
    return false;
  }
  // vertical_acceleration_value
  if (!etsi_its_cam_ts_msgs__msg__VerticalAccelerationValue__init(&msg->vertical_acceleration_value)) {
    etsi_its_cam_ts_msgs__msg__VerticalAcceleration__fini(msg);
    return false;
  }
  // vertical_acceleration_confidence
  if (!etsi_its_cam_ts_msgs__msg__AccelerationConfidence__init(&msg->vertical_acceleration_confidence)) {
    etsi_its_cam_ts_msgs__msg__VerticalAcceleration__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__fini(etsi_its_cam_ts_msgs__msg__VerticalAcceleration * msg)
{
  if (!msg) {
    return;
  }
  // vertical_acceleration_value
  etsi_its_cam_ts_msgs__msg__VerticalAccelerationValue__fini(&msg->vertical_acceleration_value);
  // vertical_acceleration_confidence
  etsi_its_cam_ts_msgs__msg__AccelerationConfidence__fini(&msg->vertical_acceleration_confidence);
}

bool
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__are_equal(const etsi_its_cam_ts_msgs__msg__VerticalAcceleration * lhs, const etsi_its_cam_ts_msgs__msg__VerticalAcceleration * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // vertical_acceleration_value
  if (!etsi_its_cam_ts_msgs__msg__VerticalAccelerationValue__are_equal(
      &(lhs->vertical_acceleration_value), &(rhs->vertical_acceleration_value)))
  {
    return false;
  }
  // vertical_acceleration_confidence
  if (!etsi_its_cam_ts_msgs__msg__AccelerationConfidence__are_equal(
      &(lhs->vertical_acceleration_confidence), &(rhs->vertical_acceleration_confidence)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__copy(
  const etsi_its_cam_ts_msgs__msg__VerticalAcceleration * input,
  etsi_its_cam_ts_msgs__msg__VerticalAcceleration * output)
{
  if (!input || !output) {
    return false;
  }
  // vertical_acceleration_value
  if (!etsi_its_cam_ts_msgs__msg__VerticalAccelerationValue__copy(
      &(input->vertical_acceleration_value), &(output->vertical_acceleration_value)))
  {
    return false;
  }
  // vertical_acceleration_confidence
  if (!etsi_its_cam_ts_msgs__msg__AccelerationConfidence__copy(
      &(input->vertical_acceleration_confidence), &(output->vertical_acceleration_confidence)))
  {
    return false;
  }
  return true;
}

etsi_its_cam_ts_msgs__msg__VerticalAcceleration *
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__VerticalAcceleration * msg = (etsi_its_cam_ts_msgs__msg__VerticalAcceleration *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__VerticalAcceleration), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__VerticalAcceleration));
  bool success = etsi_its_cam_ts_msgs__msg__VerticalAcceleration__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__destroy(etsi_its_cam_ts_msgs__msg__VerticalAcceleration * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__VerticalAcceleration__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence__init(etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__VerticalAcceleration * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__VerticalAcceleration *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__VerticalAcceleration), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__VerticalAcceleration__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__VerticalAcceleration__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence__fini(etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__VerticalAcceleration__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence *
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence * array = (etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence__destroy(etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__VerticalAcceleration__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence * input,
  etsi_its_cam_ts_msgs__msg__VerticalAcceleration__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__VerticalAcceleration);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__VerticalAcceleration * data =
      (etsi_its_cam_ts_msgs__msg__VerticalAcceleration *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__VerticalAcceleration__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__VerticalAcceleration__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__VerticalAcceleration__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
