﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/AngularAccelerationConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ANGULAR_ACCELERATION_CONFIDENCE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ANGULAR_ACCELERATION_CONFIDENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'DEG_SEC_SQUARED_01'.
enum
{
  etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence__DEG_SEC_SQUARED_01 = 0
};

/// Constant 'DEG_SEC_SQUARED_02'.
enum
{
  etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence__DEG_SEC_SQUARED_02 = 1
};

/// Constant 'DEG_SEC_SQUARED_05'.
enum
{
  etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence__DEG_SEC_SQUARED_05 = 2
};

/// Constant 'DEG_SEC_SQUARED_10'.
enum
{
  etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence__DEG_SEC_SQUARED_10 = 3
};

/// Constant 'DEG_SEC_SQUARED_20'.
enum
{
  etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence__DEG_SEC_SQUARED_20 = 4
};

/// Constant 'DEG_SEC_SQUARED_50'.
enum
{
  etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence__DEG_SEC_SQUARED_50 = 5
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence__OUT_OF_RANGE = 6
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence__UNAVAILABLE = 7
};

/// Struct defined in msg/AngularAccelerationConfidence in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// AngularAccelerationConfidence ::= ENUMERATED {
  ///     degSecSquared-01 (0),
  ///     degSecSquared-02 (1),
  ///     degSecSquared-05 (2),
  ///     degSecSquared-10 (3),
  ///     degSecSquared-20 (4),
  ///     degSecSquared-50 (5),
  ///     outOfRange       (6),
  ///     unavailable      (7)
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE indicates the angular acceleration confidence value which represents the estimated accuracy of an angular acceleration value with a default confidence level of 95 %.
  /// * If required, the confidence level can be defined by the corresponding standards applying this DE.
  /// * For correlation computation, maximum interval levels shall be assumed.
  /// *
  /// * The value shall be set to:
  /// * - 0 - `degSecSquared-01` - if the accuracy is equal to or less than 1 degree/second^2,
  /// * - 1 - `degSecSquared-02` - if the accuracy is equal to or less than 2 degrees/second^2 and greater than 1 degree/second^2,
  /// * - 2 - `degSecSquared-05` - if the accuracy is equal to or less than 5 degrees/second^2 and greater than 1 degree/second^2,
  /// * - 3 - `degSecSquared-10` - if the accuracy is equal to or less than 10 degrees/second^2 and greater than 5 degrees/second^2,
  /// * - 4 - `degSecSquared-20` - if the accuracy is equal to or less than 20 degrees/second^2 and greater than 10 degrees/second^2,
  /// * - 5 - `degSecSquared-50` - if the accuracy is equal to or less than 50 degrees/second^2 and greater than 20 degrees/second^2,
  /// * - 6 - `outOfRange`       - if the accuracy is out of range, i.e. greater than 50 degrees/second^2,
  /// * - 7 - `unavailable`      - if the accuracy information is unavailable.
  /// *
  /// * @category: Kinematic information
  /// * @revision: Created in V2.1.1
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence.
typedef struct etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence__Sequence
{
  etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__AngularAccelerationConfidence__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ANGULAR_ACCELERATION_CONFIDENCE__STRUCT_H_
