// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/BasicLaneInformation.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/basic_lane_information__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `lane_number`
// Member `connecting_lane`
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position__functions.h"
// Member `direction`
#include "etsi_its_cam_ts_msgs/msg/detail/direction__functions.h"
// Member `lane_width`
#include "etsi_its_cam_ts_msgs/msg/detail/lane_width__functions.h"
// Member `connecting_road_section`
#include "etsi_its_cam_ts_msgs/msg/detail/road_section_id__functions.h"

bool
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__init(etsi_its_cam_ts_msgs__msg__BasicLaneInformation * msg)
{
  if (!msg) {
    return false;
  }
  // lane_number
  if (!etsi_its_cam_ts_msgs__msg__LanePosition__init(&msg->lane_number)) {
    etsi_its_cam_ts_msgs__msg__BasicLaneInformation__fini(msg);
    return false;
  }
  // direction
  if (!etsi_its_cam_ts_msgs__msg__Direction__init(&msg->direction)) {
    etsi_its_cam_ts_msgs__msg__BasicLaneInformation__fini(msg);
    return false;
  }
  // lane_width
  if (!etsi_its_cam_ts_msgs__msg__LaneWidth__init(&msg->lane_width)) {
    etsi_its_cam_ts_msgs__msg__BasicLaneInformation__fini(msg);
    return false;
  }
  // lane_width_is_present
  // connecting_lane
  if (!etsi_its_cam_ts_msgs__msg__LanePosition__init(&msg->connecting_lane)) {
    etsi_its_cam_ts_msgs__msg__BasicLaneInformation__fini(msg);
    return false;
  }
  // connecting_lane_is_present
  // connecting_road_section
  if (!etsi_its_cam_ts_msgs__msg__RoadSectionId__init(&msg->connecting_road_section)) {
    etsi_its_cam_ts_msgs__msg__BasicLaneInformation__fini(msg);
    return false;
  }
  // connecting_road_section_is_present
  return true;
}

void
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__fini(etsi_its_cam_ts_msgs__msg__BasicLaneInformation * msg)
{
  if (!msg) {
    return;
  }
  // lane_number
  etsi_its_cam_ts_msgs__msg__LanePosition__fini(&msg->lane_number);
  // direction
  etsi_its_cam_ts_msgs__msg__Direction__fini(&msg->direction);
  // lane_width
  etsi_its_cam_ts_msgs__msg__LaneWidth__fini(&msg->lane_width);
  // lane_width_is_present
  // connecting_lane
  etsi_its_cam_ts_msgs__msg__LanePosition__fini(&msg->connecting_lane);
  // connecting_lane_is_present
  // connecting_road_section
  etsi_its_cam_ts_msgs__msg__RoadSectionId__fini(&msg->connecting_road_section);
  // connecting_road_section_is_present
}

bool
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__are_equal(const etsi_its_cam_ts_msgs__msg__BasicLaneInformation * lhs, const etsi_its_cam_ts_msgs__msg__BasicLaneInformation * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // lane_number
  if (!etsi_its_cam_ts_msgs__msg__LanePosition__are_equal(
      &(lhs->lane_number), &(rhs->lane_number)))
  {
    return false;
  }
  // direction
  if (!etsi_its_cam_ts_msgs__msg__Direction__are_equal(
      &(lhs->direction), &(rhs->direction)))
  {
    return false;
  }
  // lane_width
  if (!etsi_its_cam_ts_msgs__msg__LaneWidth__are_equal(
      &(lhs->lane_width), &(rhs->lane_width)))
  {
    return false;
  }
  // lane_width_is_present
  if (lhs->lane_width_is_present != rhs->lane_width_is_present) {
    return false;
  }
  // connecting_lane
  if (!etsi_its_cam_ts_msgs__msg__LanePosition__are_equal(
      &(lhs->connecting_lane), &(rhs->connecting_lane)))
  {
    return false;
  }
  // connecting_lane_is_present
  if (lhs->connecting_lane_is_present != rhs->connecting_lane_is_present) {
    return false;
  }
  // connecting_road_section
  if (!etsi_its_cam_ts_msgs__msg__RoadSectionId__are_equal(
      &(lhs->connecting_road_section), &(rhs->connecting_road_section)))
  {
    return false;
  }
  // connecting_road_section_is_present
  if (lhs->connecting_road_section_is_present != rhs->connecting_road_section_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__copy(
  const etsi_its_cam_ts_msgs__msg__BasicLaneInformation * input,
  etsi_its_cam_ts_msgs__msg__BasicLaneInformation * output)
{
  if (!input || !output) {
    return false;
  }
  // lane_number
  if (!etsi_its_cam_ts_msgs__msg__LanePosition__copy(
      &(input->lane_number), &(output->lane_number)))
  {
    return false;
  }
  // direction
  if (!etsi_its_cam_ts_msgs__msg__Direction__copy(
      &(input->direction), &(output->direction)))
  {
    return false;
  }
  // lane_width
  if (!etsi_its_cam_ts_msgs__msg__LaneWidth__copy(
      &(input->lane_width), &(output->lane_width)))
  {
    return false;
  }
  // lane_width_is_present
  output->lane_width_is_present = input->lane_width_is_present;
  // connecting_lane
  if (!etsi_its_cam_ts_msgs__msg__LanePosition__copy(
      &(input->connecting_lane), &(output->connecting_lane)))
  {
    return false;
  }
  // connecting_lane_is_present
  output->connecting_lane_is_present = input->connecting_lane_is_present;
  // connecting_road_section
  if (!etsi_its_cam_ts_msgs__msg__RoadSectionId__copy(
      &(input->connecting_road_section), &(output->connecting_road_section)))
  {
    return false;
  }
  // connecting_road_section_is_present
  output->connecting_road_section_is_present = input->connecting_road_section_is_present;
  return true;
}

etsi_its_cam_ts_msgs__msg__BasicLaneInformation *
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__BasicLaneInformation * msg = (etsi_its_cam_ts_msgs__msg__BasicLaneInformation *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__BasicLaneInformation), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__BasicLaneInformation));
  bool success = etsi_its_cam_ts_msgs__msg__BasicLaneInformation__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__destroy(etsi_its_cam_ts_msgs__msg__BasicLaneInformation * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__BasicLaneInformation__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence__init(etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__BasicLaneInformation * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__BasicLaneInformation *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__BasicLaneInformation), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__BasicLaneInformation__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__BasicLaneInformation__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence__fini(etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__BasicLaneInformation__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence *
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence * array = (etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence__destroy(etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__BasicLaneInformation__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence * input,
  etsi_its_cam_ts_msgs__msg__BasicLaneInformation__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__BasicLaneInformation);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__BasicLaneInformation * data =
      (etsi_its_cam_ts_msgs__msg__BasicLaneInformation *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__BasicLaneInformation__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__BasicLaneInformation__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__BasicLaneInformation__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
