// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/ClusterJoinInfo.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/cluster_join_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `cluster_id`
#include "etsi_its_cam_ts_msgs/msg/detail/identifier1_b__functions.h"
// Member `join_time`
#include "etsi_its_cam_ts_msgs/msg/detail/delta_time_quarter_second__functions.h"

bool
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__init(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo * msg)
{
  if (!msg) {
    return false;
  }
  // cluster_id
  if (!etsi_its_cam_ts_msgs__msg__Identifier1B__init(&msg->cluster_id)) {
    etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__fini(msg);
    return false;
  }
  // join_time
  if (!etsi_its_cam_ts_msgs__msg__DeltaTimeQuarterSecond__init(&msg->join_time)) {
    etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__fini(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo * msg)
{
  if (!msg) {
    return;
  }
  // cluster_id
  etsi_its_cam_ts_msgs__msg__Identifier1B__fini(&msg->cluster_id);
  // join_time
  etsi_its_cam_ts_msgs__msg__DeltaTimeQuarterSecond__fini(&msg->join_time);
}

bool
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__are_equal(const etsi_its_cam_ts_msgs__msg__ClusterJoinInfo * lhs, const etsi_its_cam_ts_msgs__msg__ClusterJoinInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // cluster_id
  if (!etsi_its_cam_ts_msgs__msg__Identifier1B__are_equal(
      &(lhs->cluster_id), &(rhs->cluster_id)))
  {
    return false;
  }
  // join_time
  if (!etsi_its_cam_ts_msgs__msg__DeltaTimeQuarterSecond__are_equal(
      &(lhs->join_time), &(rhs->join_time)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__copy(
  const etsi_its_cam_ts_msgs__msg__ClusterJoinInfo * input,
  etsi_its_cam_ts_msgs__msg__ClusterJoinInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // cluster_id
  if (!etsi_its_cam_ts_msgs__msg__Identifier1B__copy(
      &(input->cluster_id), &(output->cluster_id)))
  {
    return false;
  }
  // join_time
  if (!etsi_its_cam_ts_msgs__msg__DeltaTimeQuarterSecond__copy(
      &(input->join_time), &(output->join_time)))
  {
    return false;
  }
  return true;
}

etsi_its_cam_ts_msgs__msg__ClusterJoinInfo *
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ClusterJoinInfo * msg = (etsi_its_cam_ts_msgs__msg__ClusterJoinInfo *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo));
  bool success = etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__destroy(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence__init(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ClusterJoinInfo * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__ClusterJoinInfo *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence__fini(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence *
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence * array = (etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence__destroy(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence * input,
  etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__ClusterJoinInfo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__ClusterJoinInfo * data =
      (etsi_its_cam_ts_msgs__msg__ClusterJoinInfo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__ClusterJoinInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
