﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/HeightLonCarr.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEIGHT_LON_CARR__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEIGHT_LON_CARR__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeightLonCarr__MIN = 1
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeightLonCarr__MAX = 100
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeightLonCarr__OUT_OF_RANGE = 99
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__HeightLonCarr__UNAVAILABLE = 100
};

/// Struct defined in msg/HeightLonCarr in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__HeightLonCarr
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// HeightLonCarr ::= INTEGER {
  ///     outOfRange(99),
  ///     unavailable(100)
  /// } (1..100)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the height of the left or right longitude carrier of vehicle from base to top (left or right carrier seen from vehicle
  /// * rear to front).
  /// *
  /// * The value shall be set to:
  /// * - `n` (`n >= 1` and `n < 99`) if the height information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
  /// * - `99` if the height is out of range, i.e. equal to or greater than 0,98 m,
  /// * - `100` if the height information is not available.
  /// *
  /// * @unit 0,01 metre
  /// * @category Vehicle information
  /// * @revision: Description revised in V2.1.1 (the definition of 99 has changed slightly)
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__HeightLonCarr;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__HeightLonCarr.
typedef struct etsi_its_cam_ts_msgs__msg__HeightLonCarr__Sequence
{
  etsi_its_cam_ts_msgs__msg__HeightLonCarr * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__HeightLonCarr__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEIGHT_LON_CARR__STRUCT_H_
