// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/InterferenceManagementChannel.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_CHANNEL__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_CHANNEL__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__InterferenceManagementChannel __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__InterferenceManagementChannel __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct InterferenceManagementChannel_
{
  using Type = InterferenceManagementChannel_<ContainerAllocator>;

  explicit InterferenceManagementChannel_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->centre_frequency = 0ul;
      this->channel_width = 0;
      this->exponent = 0;
    }
  }

  explicit InterferenceManagementChannel_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->centre_frequency = 0ul;
      this->channel_width = 0;
      this->exponent = 0;
    }
  }

  // field types and members
  using _centre_frequency_type =
    uint32_t;
  _centre_frequency_type centre_frequency;
  using _channel_width_type =
    uint16_t;
  _channel_width_type channel_width;
  using _exponent_type =
    uint8_t;
  _exponent_type exponent;

  // setters for named parameter idiom
  Type & set__centre_frequency(
    const uint32_t & _arg)
  {
    this->centre_frequency = _arg;
    return *this;
  }
  Type & set__channel_width(
    const uint16_t & _arg)
  {
    this->channel_width = _arg;
    return *this;
  }
  Type & set__exponent(
    const uint8_t & _arg)
  {
    this->exponent = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint32_t CENTRE_FREQUENCY_MIN =
    1u;
  static constexpr uint32_t CENTRE_FREQUENCY_MAX =
    99999u;
  static constexpr uint16_t CHANNEL_WIDTH_MIN =
    0u;
  static constexpr uint16_t CHANNEL_WIDTH_MAX =
    9999u;
  static constexpr uint8_t EXPONENT_MIN =
    0u;
  static constexpr uint8_t EXPONENT_MAX =
    15u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__InterferenceManagementChannel
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__InterferenceManagementChannel
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const InterferenceManagementChannel_ & other) const
  {
    if (this->centre_frequency != other.centre_frequency) {
      return false;
    }
    if (this->channel_width != other.channel_width) {
      return false;
    }
    if (this->exponent != other.exponent) {
      return false;
    }
    return true;
  }
  bool operator!=(const InterferenceManagementChannel_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct InterferenceManagementChannel_

// alias to use template instance with default allocator
using InterferenceManagementChannel =
  etsi_its_cam_ts_msgs::msg::InterferenceManagementChannel_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t InterferenceManagementChannel_<ContainerAllocator>::CENTRE_FREQUENCY_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t InterferenceManagementChannel_<ContainerAllocator>::CENTRE_FREQUENCY_MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t InterferenceManagementChannel_<ContainerAllocator>::CHANNEL_WIDTH_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t InterferenceManagementChannel_<ContainerAllocator>::CHANNEL_WIDTH_MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t InterferenceManagementChannel_<ContainerAllocator>::EXPONENT_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t InterferenceManagementChannel_<ContainerAllocator>::EXPONENT_MAX;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_CHANNEL__STRUCT_HPP_
