// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/LanePositionAndType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_AND_TYPE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_AND_TYPE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'transversal_position'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position__struct.hpp"
// Member 'lane_type'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_type__struct.hpp"
// Member 'direction'
#include "etsi_its_cam_ts_msgs/msg/detail/direction__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__LanePositionAndType __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__LanePositionAndType __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LanePositionAndType_
{
  using Type = LanePositionAndType_<ContainerAllocator>;

  explicit LanePositionAndType_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : transversal_position(_init),
    lane_type(_init),
    direction(_init)
  {
    (void)_init;
  }

  explicit LanePositionAndType_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : transversal_position(_alloc, _init),
    lane_type(_alloc, _init),
    direction(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _transversal_position_type =
    etsi_its_cam_ts_msgs::msg::LanePosition_<ContainerAllocator>;
  _transversal_position_type transversal_position;
  using _lane_type_type =
    etsi_its_cam_ts_msgs::msg::LaneType_<ContainerAllocator>;
  _lane_type_type lane_type;
  using _direction_type =
    etsi_its_cam_ts_msgs::msg::Direction_<ContainerAllocator>;
  _direction_type direction;

  // setters for named parameter idiom
  Type & set__transversal_position(
    const etsi_its_cam_ts_msgs::msg::LanePosition_<ContainerAllocator> & _arg)
  {
    this->transversal_position = _arg;
    return *this;
  }
  Type & set__lane_type(
    const etsi_its_cam_ts_msgs::msg::LaneType_<ContainerAllocator> & _arg)
  {
    this->lane_type = _arg;
    return *this;
  }
  Type & set__direction(
    const etsi_its_cam_ts_msgs::msg::Direction_<ContainerAllocator> & _arg)
  {
    this->direction = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t LANE_TYPE_DEFAULT =
    0u;
  static constexpr uint8_t DIRECTION_DEFAULT =
    0u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__LanePositionAndType
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__LanePositionAndType
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LanePositionAndType_ & other) const
  {
    if (this->transversal_position != other.transversal_position) {
      return false;
    }
    if (this->lane_type != other.lane_type) {
      return false;
    }
    if (this->direction != other.direction) {
      return false;
    }
    return true;
  }
  bool operator!=(const LanePositionAndType_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LanePositionAndType_

// alias to use template instance with default allocator
using LanePositionAndType =
  etsi_its_cam_ts_msgs::msg::LanePositionAndType_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t LanePositionAndType_<ContainerAllocator>::LANE_TYPE_DEFAULT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t LanePositionAndType_<ContainerAllocator>::DIRECTION_DEFAULT;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_AND_TYPE__STRUCT_HPP_
