// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/MetaInformation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__META_INFORMATION__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__META_INFORMATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/meta_information__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'used_detection_information'
#include "etsi_its_cam_ts_msgs/msg/detail/sensor_types__traits.hpp"
// Member 'used_stored_information'
#include "etsi_its_cam_ts_msgs/msg/detail/stored_information_type__traits.hpp"
// Member 'confidence_value'
#include "etsi_its_cam_ts_msgs/msg/detail/confidence_level__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MetaInformation & msg,
  std::ostream & out)
{
  out << "{";
  // member: used_detection_information
  {
    out << "used_detection_information: ";
    to_flow_style_yaml(msg.used_detection_information, out);
    out << ", ";
  }

  // member: used_stored_information
  {
    out << "used_stored_information: ";
    to_flow_style_yaml(msg.used_stored_information, out);
    out << ", ";
  }

  // member: confidence_value
  {
    out << "confidence_value: ";
    to_flow_style_yaml(msg.confidence_value, out);
    out << ", ";
  }

  // member: confidence_value_is_present
  {
    out << "confidence_value_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.confidence_value_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MetaInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: used_detection_information
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "used_detection_information:\n";
    to_block_style_yaml(msg.used_detection_information, out, indentation + 2);
  }

  // member: used_stored_information
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "used_stored_information:\n";
    to_block_style_yaml(msg.used_stored_information, out, indentation + 2);
  }

  // member: confidence_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confidence_value:\n";
    to_block_style_yaml(msg.confidence_value, out, indentation + 2);
  }

  // member: confidence_value_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confidence_value_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.confidence_value_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MetaInformation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::MetaInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::MetaInformation & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::MetaInformation>()
{
  return "etsi_its_cam_ts_msgs::msg::MetaInformation";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::MetaInformation>()
{
  return "etsi_its_cam_ts_msgs/msg/MetaInformation";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::MetaInformation>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::ConfidenceLevel>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::SensorTypes>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::StoredInformationType>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::MetaInformation>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::ConfidenceLevel>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::SensorTypes>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::StoredInformationType>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::MetaInformation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__META_INFORMATION__TRAITS_HPP_
