// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/MitigationPerTechnologyClass.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__MITIGATION_PER_TECHNOLOGY_CLASS__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__MITIGATION_PER_TECHNOLOGY_CLASS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/mitigation_per_technology_class__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'access_technology_class'
#include "etsi_its_cam_ts_msgs/msg/detail/access_technology_class__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MitigationPerTechnologyClass & msg,
  std::ostream & out)
{
  out << "{";
  // member: access_technology_class
  {
    out << "access_technology_class: ";
    to_flow_style_yaml(msg.access_technology_class, out);
    out << ", ";
  }

  // member: low_duty_cycle
  {
    out << "low_duty_cycle: ";
    rosidl_generator_traits::value_to_yaml(msg.low_duty_cycle, out);
    out << ", ";
  }

  // member: low_duty_cycle_is_present
  {
    out << "low_duty_cycle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.low_duty_cycle_is_present, out);
    out << ", ";
  }

  // member: power_reduction
  {
    out << "power_reduction: ";
    rosidl_generator_traits::value_to_yaml(msg.power_reduction, out);
    out << ", ";
  }

  // member: power_reduction_is_present
  {
    out << "power_reduction_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.power_reduction_is_present, out);
    out << ", ";
  }

  // member: dmc_toff_limit
  {
    out << "dmc_toff_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.dmc_toff_limit, out);
    out << ", ";
  }

  // member: dmc_toff_limit_is_present
  {
    out << "dmc_toff_limit_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.dmc_toff_limit_is_present, out);
    out << ", ";
  }

  // member: dmc_ton_limit
  {
    out << "dmc_ton_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.dmc_ton_limit, out);
    out << ", ";
  }

  // member: dmc_ton_limit_is_present
  {
    out << "dmc_ton_limit_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.dmc_ton_limit_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MitigationPerTechnologyClass & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: access_technology_class
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "access_technology_class:\n";
    to_block_style_yaml(msg.access_technology_class, out, indentation + 2);
  }

  // member: low_duty_cycle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "low_duty_cycle: ";
    rosidl_generator_traits::value_to_yaml(msg.low_duty_cycle, out);
    out << "\n";
  }

  // member: low_duty_cycle_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "low_duty_cycle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.low_duty_cycle_is_present, out);
    out << "\n";
  }

  // member: power_reduction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "power_reduction: ";
    rosidl_generator_traits::value_to_yaml(msg.power_reduction, out);
    out << "\n";
  }

  // member: power_reduction_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "power_reduction_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.power_reduction_is_present, out);
    out << "\n";
  }

  // member: dmc_toff_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dmc_toff_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.dmc_toff_limit, out);
    out << "\n";
  }

  // member: dmc_toff_limit_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dmc_toff_limit_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.dmc_toff_limit_is_present, out);
    out << "\n";
  }

  // member: dmc_ton_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dmc_ton_limit: ";
    rosidl_generator_traits::value_to_yaml(msg.dmc_ton_limit, out);
    out << "\n";
  }

  // member: dmc_ton_limit_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dmc_ton_limit_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.dmc_ton_limit_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MitigationPerTechnologyClass & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass>()
{
  return "etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass>()
{
  return "etsi_its_cam_ts_msgs/msg/MitigationPerTechnologyClass";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::AccessTechnologyClass>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::AccessTechnologyClass>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::MitigationPerTechnologyClass>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__MITIGATION_PER_TECHNOLOGY_CLASS__TRAITS_HPP_
