// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/PathPointPredicted.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_POINT_PREDICTED__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_POINT_PREDICTED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'delta_latitude'
#include "etsi_its_cam_ts_msgs/msg/detail/delta_latitude__struct.hpp"
// Member 'delta_longitude'
#include "etsi_its_cam_ts_msgs/msg/detail/delta_longitude__struct.hpp"
// Member 'horizontal_position_confidence'
#include "etsi_its_cam_ts_msgs/msg/detail/pos_confidence_ellipse__struct.hpp"
// Member 'delta_altitude'
#include "etsi_its_cam_ts_msgs/msg/detail/delta_altitude__struct.hpp"
// Member 'altitude_confidence'
#include "etsi_its_cam_ts_msgs/msg/detail/altitude_confidence__struct.hpp"
// Member 'path_delta_time'
#include "etsi_its_cam_ts_msgs/msg/detail/path_delta_time_choice__struct.hpp"
// Member 'symmetric_area_offset'
// Member 'asymmetric_area_offset'
#include "etsi_its_cam_ts_msgs/msg/detail/standard_length9b__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__PathPointPredicted __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__PathPointPredicted __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PathPointPredicted_
{
  using Type = PathPointPredicted_<ContainerAllocator>;

  explicit PathPointPredicted_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : delta_latitude(_init),
    delta_longitude(_init),
    horizontal_position_confidence(_init),
    delta_altitude(_init),
    altitude_confidence(_init),
    path_delta_time(_init),
    symmetric_area_offset(_init),
    asymmetric_area_offset(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->horizontal_position_confidence_is_present = false;
      this->path_delta_time_is_present = false;
      this->symmetric_area_offset_is_present = false;
      this->asymmetric_area_offset_is_present = false;
    }
  }

  explicit PathPointPredicted_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : delta_latitude(_alloc, _init),
    delta_longitude(_alloc, _init),
    horizontal_position_confidence(_alloc, _init),
    delta_altitude(_alloc, _init),
    altitude_confidence(_alloc, _init),
    path_delta_time(_alloc, _init),
    symmetric_area_offset(_alloc, _init),
    asymmetric_area_offset(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->horizontal_position_confidence_is_present = false;
      this->path_delta_time_is_present = false;
      this->symmetric_area_offset_is_present = false;
      this->asymmetric_area_offset_is_present = false;
    }
  }

  // field types and members
  using _delta_latitude_type =
    etsi_its_cam_ts_msgs::msg::DeltaLatitude_<ContainerAllocator>;
  _delta_latitude_type delta_latitude;
  using _delta_longitude_type =
    etsi_its_cam_ts_msgs::msg::DeltaLongitude_<ContainerAllocator>;
  _delta_longitude_type delta_longitude;
  using _horizontal_position_confidence_type =
    etsi_its_cam_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator>;
  _horizontal_position_confidence_type horizontal_position_confidence;
  using _horizontal_position_confidence_is_present_type =
    bool;
  _horizontal_position_confidence_is_present_type horizontal_position_confidence_is_present;
  using _delta_altitude_type =
    etsi_its_cam_ts_msgs::msg::DeltaAltitude_<ContainerAllocator>;
  _delta_altitude_type delta_altitude;
  using _altitude_confidence_type =
    etsi_its_cam_ts_msgs::msg::AltitudeConfidence_<ContainerAllocator>;
  _altitude_confidence_type altitude_confidence;
  using _path_delta_time_type =
    etsi_its_cam_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator>;
  _path_delta_time_type path_delta_time;
  using _path_delta_time_is_present_type =
    bool;
  _path_delta_time_is_present_type path_delta_time_is_present;
  using _symmetric_area_offset_type =
    etsi_its_cam_ts_msgs::msg::StandardLength9b_<ContainerAllocator>;
  _symmetric_area_offset_type symmetric_area_offset;
  using _symmetric_area_offset_is_present_type =
    bool;
  _symmetric_area_offset_is_present_type symmetric_area_offset_is_present;
  using _asymmetric_area_offset_type =
    etsi_its_cam_ts_msgs::msg::StandardLength9b_<ContainerAllocator>;
  _asymmetric_area_offset_type asymmetric_area_offset;
  using _asymmetric_area_offset_is_present_type =
    bool;
  _asymmetric_area_offset_is_present_type asymmetric_area_offset_is_present;

  // setters for named parameter idiom
  Type & set__delta_latitude(
    const etsi_its_cam_ts_msgs::msg::DeltaLatitude_<ContainerAllocator> & _arg)
  {
    this->delta_latitude = _arg;
    return *this;
  }
  Type & set__delta_longitude(
    const etsi_its_cam_ts_msgs::msg::DeltaLongitude_<ContainerAllocator> & _arg)
  {
    this->delta_longitude = _arg;
    return *this;
  }
  Type & set__horizontal_position_confidence(
    const etsi_its_cam_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator> & _arg)
  {
    this->horizontal_position_confidence = _arg;
    return *this;
  }
  Type & set__horizontal_position_confidence_is_present(
    const bool & _arg)
  {
    this->horizontal_position_confidence_is_present = _arg;
    return *this;
  }
  Type & set__delta_altitude(
    const etsi_its_cam_ts_msgs::msg::DeltaAltitude_<ContainerAllocator> & _arg)
  {
    this->delta_altitude = _arg;
    return *this;
  }
  Type & set__altitude_confidence(
    const etsi_its_cam_ts_msgs::msg::AltitudeConfidence_<ContainerAllocator> & _arg)
  {
    this->altitude_confidence = _arg;
    return *this;
  }
  Type & set__path_delta_time(
    const etsi_its_cam_ts_msgs::msg::PathDeltaTimeChoice_<ContainerAllocator> & _arg)
  {
    this->path_delta_time = _arg;
    return *this;
  }
  Type & set__path_delta_time_is_present(
    const bool & _arg)
  {
    this->path_delta_time_is_present = _arg;
    return *this;
  }
  Type & set__symmetric_area_offset(
    const etsi_its_cam_ts_msgs::msg::StandardLength9b_<ContainerAllocator> & _arg)
  {
    this->symmetric_area_offset = _arg;
    return *this;
  }
  Type & set__symmetric_area_offset_is_present(
    const bool & _arg)
  {
    this->symmetric_area_offset_is_present = _arg;
    return *this;
  }
  Type & set__asymmetric_area_offset(
    const etsi_its_cam_ts_msgs::msg::StandardLength9b_<ContainerAllocator> & _arg)
  {
    this->asymmetric_area_offset = _arg;
    return *this;
  }
  Type & set__asymmetric_area_offset_is_present(
    const bool & _arg)
  {
    this->asymmetric_area_offset_is_present = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int16_t DELTA_ALTITUDE_DEFAULT =
    12800;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__PathPointPredicted
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__PathPointPredicted
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PathPointPredicted_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PathPointPredicted_ & other) const
  {
    if (this->delta_latitude != other.delta_latitude) {
      return false;
    }
    if (this->delta_longitude != other.delta_longitude) {
      return false;
    }
    if (this->horizontal_position_confidence != other.horizontal_position_confidence) {
      return false;
    }
    if (this->horizontal_position_confidence_is_present != other.horizontal_position_confidence_is_present) {
      return false;
    }
    if (this->delta_altitude != other.delta_altitude) {
      return false;
    }
    if (this->altitude_confidence != other.altitude_confidence) {
      return false;
    }
    if (this->path_delta_time != other.path_delta_time) {
      return false;
    }
    if (this->path_delta_time_is_present != other.path_delta_time_is_present) {
      return false;
    }
    if (this->symmetric_area_offset != other.symmetric_area_offset) {
      return false;
    }
    if (this->symmetric_area_offset_is_present != other.symmetric_area_offset_is_present) {
      return false;
    }
    if (this->asymmetric_area_offset != other.asymmetric_area_offset) {
      return false;
    }
    if (this->asymmetric_area_offset_is_present != other.asymmetric_area_offset_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const PathPointPredicted_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PathPointPredicted_

// alias to use template instance with default allocator
using PathPointPredicted =
  etsi_its_cam_ts_msgs::msg::PathPointPredicted_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int16_t PathPointPredicted_<ContainerAllocator>::DELTA_ALTITUDE_DEFAULT;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_POINT_PREDICTED__STRUCT_HPP_
