﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/StandardLength3b.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STANDARD_LENGTH3B__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STANDARD_LENGTH3B__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'LESS_THAN50M'.
enum
{
  etsi_its_cam_ts_msgs__msg__StandardLength3b__LESS_THAN50M = 0
};

/// Constant 'LESS_THAN100M'.
enum
{
  etsi_its_cam_ts_msgs__msg__StandardLength3b__LESS_THAN100M = 1
};

/// Constant 'LESS_THAN200M'.
enum
{
  etsi_its_cam_ts_msgs__msg__StandardLength3b__LESS_THAN200M = 2
};

/// Constant 'LESS_THAN500M'.
enum
{
  etsi_its_cam_ts_msgs__msg__StandardLength3b__LESS_THAN500M = 3
};

/// Constant 'LESS_THAN1000M'.
enum
{
  etsi_its_cam_ts_msgs__msg__StandardLength3b__LESS_THAN1000M = 4
};

/// Constant 'LESS_THAN5KM'.
enum
{
  etsi_its_cam_ts_msgs__msg__StandardLength3b__LESS_THAN5KM = 5
};

/// Constant 'LESS_THAN10KM'.
enum
{
  etsi_its_cam_ts_msgs__msg__StandardLength3b__LESS_THAN10KM = 6
};

/// Constant 'OVER10KM'.
enum
{
  etsi_its_cam_ts_msgs__msg__StandardLength3b__OVER10KM = 7
};

/// Struct defined in msg/StandardLength3b in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__StandardLength3b
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// StandardLength3b ::= ENUMERATED {
  ///     lessThan50m   (0),
  ///     lessThan100m  (1),
  ///     lessThan200m  (2),
  ///     lessThan500m  (3),
  ///     lessThan1000m (4),
  ///     lessThan5km   (5),
  ///     lessThan10km  (6),
  ///     over10km      (7)
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * The DE represents length as a measure of distance between points.
  /// *
  /// * The value shall be set to:
  /// * - 0 `lessThan50m`   - for distances below 50 m,
  /// * - 1 `lessThan100m`  - for distances below 100 m,
  /// * - 2 `lessThan200m`  - for distances below 200 m,
  /// * - 3 `lessThan500m`  - for distances below 300 m,
  /// * - 4 `lessThan1000m` - for distances below 1 000 m,
  /// * - 5 `lessThan5km`   - for distances below 5 000 m,
  /// * - 6 `lessThan10km`  - for distances below 10 000 m,
  /// * - 7 `over10km`      - for distances over 10 000 m.
  /// *
  /// * @category: GeoReference information
  /// * @revision: Created in V2.1.1 from RelevanceDistance
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__StandardLength3b;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__StandardLength3b.
typedef struct etsi_its_cam_ts_msgs__msg__StandardLength3b__Sequence
{
  etsi_its_cam_ts_msgs__msg__StandardLength3b * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__StandardLength3b__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STANDARD_LENGTH3B__STRUCT_H_
